/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.edge;


import java.util.ArrayList;
import java.util.IdentityHashMap;
import java.util.List;
import java.util.Map;

import de.hft.stuttgart.citydoctor2.datastructure.Geometry;
import de.hft.stuttgart.citydoctor2.datastructure.Polygon;
import de.hft.stuttgart.citydoctor2.datastructure.Vertex;

public class MeshSurface {
	
	private List<CDPolygonNs> polygons;
	
	public static MeshSurface of(Geometry geom) {
		List<CDPolygonNs> polygonList = new ArrayList<>();
		
		Map<Vertex, Coordinate3d> pointMap = new IdentityHashMap<>();
		for (Polygon p : geom.getPolygons()) {
			CDPolygonNs poly = CDPolygonNs.of(p, pointMap);
			polygonList.add(poly);
//			HalfEdge firstHalfEdge = poly.getFirstHalfEdge();
//			System.out.println();
//			System.out.println(firstHalfEdge.getStart());
//			System.out.println(firstHalfEdge.getEnd());
//			HalfEdge next = firstHalfEdge.getNext();
//			while (next != firstHalfEdge) {
//				System.out.println(next.getEnd());
//				next = next.getNext();
//			}
		}
		return new MeshSurface(polygonList);
	}
	
	public MeshSurface(List<CDPolygonNs> polygons) {
		this.polygons = polygons;
	}
	
	public List<CDPolygonNs> getPolygons() {
		return polygons;
	}

}
